import { css as $t, html as Pe, LitElement as Yr } from "lit";
import { property as je, query as qr, queryAssignedElements as It, state as Be, customElement as zr } from "lit/decorators.js";
const ze = {
  autostart: "1",
  autospin: "0.2",
  preload: "1",
  ui_infos: "0",
  ui_stop: "0",
  ui_controls: "1",
  ui_fadeout: "0",
  ui_fullscreen: "0",
  ui_settings: "0",
  ui_help: "0",
  ui_inspector: "0",
  ui_vr: "0",
  ui_ar: "0",
  ui_watermark: "0",
  ui_ar_help: "0",
  ui_ar_qrcode: "0",
  ui_loading: "0"
}, Br = "https://sketchfab.com/models/", Hr = "/embed?", Pt = {
  api_id: "1",
  api_version: "1.12.1"
}, Gr = $t`
  .main-container {
    position: relative;
    display: flex;
    align-items: center;
    justify-content: center;
    height: 100%;
    width: 100%;
  }
  .hidden {
    opacity: 0 !important;
  }
  iframe {
    transition: opacity 1s;
    position: absolute;
    width: 100%;
    height: 100%;
  }
  .full-screen {
    height: 100vh;
    overflow: hidden;
  }
  .lds-grid {
    display: inline-block;
    position: relative;
    width: 80px;
    height: 80px;
  }
  .lds-grid div {
    position: absolute;
    width: 16px;
    height: 16px;
    border-radius: 50%;
    background: #fff;
    animation: lds-grid 1.2s linear infinite;
  }
  .lds-grid div:nth-child(1) {
    top: 8px;
    left: 8px;
    animation-delay: 0s;
  }
  .lds-grid div:nth-child(2) {
    top: 8px;
    left: 32px;
    animation-delay: -0.4s;
  }
  .lds-grid div:nth-child(3) {
    top: 8px;
    left: 56px;
    animation-delay: -0.8s;
  }
  .lds-grid div:nth-child(4) {
    top: 32px;
    left: 8px;
    animation-delay: -0.4s;
  }
  .lds-grid div:nth-child(5) {
    top: 32px;
    left: 32px;
    animation-delay: -0.8s;
  }
  .lds-grid div:nth-child(6) {
    top: 32px;
    left: 56px;
    animation-delay: -1.2s;
  }
  .lds-grid div:nth-child(7) {
    top: 56px;
    left: 8px;
    animation-delay: -0.8s;
  }
  .lds-grid div:nth-child(8) {
    top: 56px;
    left: 32px;
    animation-delay: -1.2s;
  }
  .lds-grid div:nth-child(9) {
    top: 56px;
    left: 56px;
    animation-delay: -1.6s;
  }
  @keyframes lds-grid {
    0%,
    100% {
      opacity: 1;
    }
    50% {
      opacity: 0.5;
    }
  }
`;
function Kr() {
  return Pe`<div id="loader">
    <div class="lds-grid">
      <div></div>
      <div></div>
      <div></div>
      <div></div>
      <div></div>
      <div></div>
      <div></div>
      <div></div>
      <div></div>
    </div>
  </div>`;
}
/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const Qr = /* @__PURE__ */ new Set(["children", "localName", "ref", "style", "className"]), jt = /* @__PURE__ */ new WeakMap(), Jr = (f, u, k, j, T) => {
  const P = T == null ? void 0 : T[u];
  P === void 0 || k === j ? k == null && u in HTMLElement.prototype ? f.removeAttribute(u) : f[u] = k : ((A, M, H) => {
    let N = jt.get(A);
    N === void 0 && jt.set(A, N = /* @__PURE__ */ new Map());
    let L = N.get(M);
    H !== void 0 ? L === void 0 ? (N.set(M, L = { handleEvent: H }), A.addEventListener(M, L)) : L.handleEvent = H : L !== void 0 && (N.delete(M), A.removeEventListener(M, L));
  })(f, P, k);
};
function Xr(f = window.React, u, k, j, T) {
  let P, A, M;
  if (u === void 0) {
    const I = f;
    ({ tagName: A, elementClass: M, events: j, displayName: T } = I), P = I.react;
  } else
    P = f, M = k, A = u;
  const H = P.Component, N = P.createElement, L = new Set(Object.keys(j != null ? j : {}));
  class G extends H {
    constructor() {
      super(...arguments), this.o = null;
    }
    t(x) {
      if (this.o !== null)
        for (const q in this.i)
          Jr(this.o, q, this.props[q], x ? x[q] : void 0, j);
    }
    componentDidMount() {
      this.t();
    }
    componentDidUpdate(x) {
      this.t(x);
    }
    render() {
      var x;
      const q = (x = this.props._$Gl) !== null && x !== void 0 ? x : null;
      this.h !== void 0 && this.u === q || (this.h = (F) => {
        this.o === null && (this.o = F), q !== null && ((W, J) => {
          typeof W == "function" ? W(J) : W.current = J;
        })(q, F), this.u = q;
      });
      const z = { ref: this.h };
      this.i = {};
      for (const [F, W] of Object.entries(this.props))
        F !== "__forwardedRef" && (Qr.has(F) ? z[F === "className" ? "class" : F] = W : L.has(F) || F in M.prototype ? this.i[F] = W : z[F] = W);
      return N(A, z);
    }
  }
  G.displayName = T != null ? T : M.name;
  const Z = P.forwardRef((I, x) => N(G, { ...I, _$Gl: x }, I == null ? void 0 : I.children));
  return Z.displayName = G.displayName, Z;
}
function Zr(f) {
  return f && f.__esModule && Object.prototype.hasOwnProperty.call(f, "default") ? f.default : f;
}
var Dt = { exports: {} }, v = {};
/**
 * @license React
 * react.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var At;
function en() {
  if (At)
    return v;
  At = 1;
  var f = Symbol.for("react.element"), u = Symbol.for("react.portal"), k = Symbol.for("react.fragment"), j = Symbol.for("react.strict_mode"), T = Symbol.for("react.profiler"), P = Symbol.for("react.provider"), A = Symbol.for("react.context"), M = Symbol.for("react.forward_ref"), H = Symbol.for("react.suspense"), N = Symbol.for("react.memo"), L = Symbol.for("react.lazy"), G = Symbol.iterator;
  function Z(r) {
    return r === null || typeof r != "object" ? null : (r = G && r[G] || r["@@iterator"], typeof r == "function" ? r : null);
  }
  var I = { isMounted: function() {
    return !1;
  }, enqueueForceUpdate: function() {
  }, enqueueReplaceState: function() {
  }, enqueueSetState: function() {
  } }, x = Object.assign, q = {};
  function z(r, i, p) {
    this.props = r, this.context = i, this.refs = q, this.updater = p || I;
  }
  z.prototype.isReactComponent = {}, z.prototype.setState = function(r, i) {
    if (typeof r != "object" && typeof r != "function" && r != null)
      throw Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");
    this.updater.enqueueSetState(this, r, i, "setState");
  }, z.prototype.forceUpdate = function(r) {
    this.updater.enqueueForceUpdate(this, r, "forceUpdate");
  };
  function F() {
  }
  F.prototype = z.prototype;
  function W(r, i, p) {
    this.props = r, this.context = i, this.refs = q, this.updater = p || I;
  }
  var J = W.prototype = new F();
  J.constructor = W, x(J, z.prototype), J.isPureReactComponent = !0;
  var X = Array.isArray, $ = Object.prototype.hasOwnProperty, B = { current: null }, ee = { key: !0, ref: !0, __self: !0, __source: !0 };
  function ne(r, i, p) {
    var m, h = {}, g = null, S = null;
    if (i != null)
      for (m in i.ref !== void 0 && (S = i.ref), i.key !== void 0 && (g = "" + i.key), i)
        $.call(i, m) && !ee.hasOwnProperty(m) && (h[m] = i[m]);
    var b = arguments.length - 2;
    if (b === 1)
      h.children = p;
    else if (1 < b) {
      for (var w = Array(b), U = 0; U < b; U++)
        w[U] = arguments[U + 2];
      h.children = w;
    }
    if (r && r.defaultProps)
      for (m in b = r.defaultProps, b)
        h[m] === void 0 && (h[m] = b[m]);
    return { $$typeof: f, type: r, key: g, ref: S, props: h, _owner: B.current };
  }
  function ve(r, i) {
    return { $$typeof: f, type: r.type, key: i, ref: r.ref, props: r.props, _owner: r._owner };
  }
  function le(r) {
    return typeof r == "object" && r !== null && r.$$typeof === f;
  }
  function Ae(r) {
    var i = { "=": "=0", ":": "=2" };
    return "$" + r.replace(/[=:]/g, function(p) {
      return i[p];
    });
  }
  var he = /\/+/g;
  function ce(r, i) {
    return typeof r == "object" && r !== null && r.key != null ? Ae("" + r.key) : i.toString(36);
  }
  function oe(r, i, p, m, h) {
    var g = typeof r;
    (g === "undefined" || g === "boolean") && (r = null);
    var S = !1;
    if (r === null)
      S = !0;
    else
      switch (g) {
        case "string":
        case "number":
          S = !0;
          break;
        case "object":
          switch (r.$$typeof) {
            case f:
            case u:
              S = !0;
          }
      }
    if (S)
      return S = r, h = h(S), r = m === "" ? "." + ce(S, 0) : m, X(h) ? (p = "", r != null && (p = r.replace(he, "$&/") + "/"), oe(h, i, p, "", function(U) {
        return U;
      })) : h != null && (le(h) && (h = ve(h, p + (!h.key || S && S.key === h.key ? "" : ("" + h.key).replace(he, "$&/") + "/") + r)), i.push(h)), 1;
    if (S = 0, m = m === "" ? "." : m + ":", X(r))
      for (var b = 0; b < r.length; b++) {
        g = r[b];
        var w = m + ce(g, b);
        S += oe(g, i, p, w, h);
      }
    else if (w = Z(r), typeof w == "function")
      for (r = w.call(r), b = 0; !(g = r.next()).done; )
        g = g.value, w = m + ce(g, b++), S += oe(g, i, p, w, h);
    else if (g === "object")
      throw i = String(r), Error("Objects are not valid as a React child (found: " + (i === "[object Object]" ? "object with keys {" + Object.keys(r).join(", ") + "}" : i) + "). If you meant to render a collection of children, use an array instead.");
    return S;
  }
  function K(r, i, p) {
    if (r == null)
      return r;
    var m = [], h = 0;
    return oe(r, m, "", "", function(g) {
      return i.call(p, g, h++);
    }), m;
  }
  function te(r) {
    if (r._status === -1) {
      var i = r._result;
      i = i(), i.then(function(p) {
        (r._status === 0 || r._status === -1) && (r._status = 1, r._result = p);
      }, function(p) {
        (r._status === 0 || r._status === -1) && (r._status = 2, r._result = p);
      }), r._status === -1 && (r._status = 0, r._result = i);
    }
    if (r._status === 1)
      return r._result.default;
    throw r._result;
  }
  var c = { current: null }, ae = { transition: null }, ye = { ReactCurrentDispatcher: c, ReactCurrentBatchConfig: ae, ReactCurrentOwner: B };
  return v.Children = { map: K, forEach: function(r, i, p) {
    K(r, function() {
      i.apply(this, arguments);
    }, p);
  }, count: function(r) {
    var i = 0;
    return K(r, function() {
      i++;
    }), i;
  }, toArray: function(r) {
    return K(r, function(i) {
      return i;
    }) || [];
  }, only: function(r) {
    if (!le(r))
      throw Error("React.Children.only expected to receive a single React element child.");
    return r;
  } }, v.Component = z, v.Fragment = k, v.Profiler = T, v.PureComponent = W, v.StrictMode = j, v.Suspense = H, v.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = ye, v.cloneElement = function(r, i, p) {
    if (r == null)
      throw Error("React.cloneElement(...): The argument must be a React element, but you passed " + r + ".");
    var m = x({}, r.props), h = r.key, g = r.ref, S = r._owner;
    if (i != null) {
      if (i.ref !== void 0 && (g = i.ref, S = B.current), i.key !== void 0 && (h = "" + i.key), r.type && r.type.defaultProps)
        var b = r.type.defaultProps;
      for (w in i)
        $.call(i, w) && !ee.hasOwnProperty(w) && (m[w] = i[w] === void 0 && b !== void 0 ? b[w] : i[w]);
    }
    var w = arguments.length - 2;
    if (w === 1)
      m.children = p;
    else if (1 < w) {
      b = Array(w);
      for (var U = 0; U < w; U++)
        b[U] = arguments[U + 2];
      m.children = b;
    }
    return { $$typeof: f, type: r.type, key: h, ref: g, props: m, _owner: S };
  }, v.createContext = function(r) {
    return r = { $$typeof: A, _currentValue: r, _currentValue2: r, _threadCount: 0, Provider: null, Consumer: null, _defaultValue: null, _globalName: null }, r.Provider = { $$typeof: P, _context: r }, r.Consumer = r;
  }, v.createElement = ne, v.createFactory = function(r) {
    var i = ne.bind(null, r);
    return i.type = r, i;
  }, v.createRef = function() {
    return { current: null };
  }, v.forwardRef = function(r) {
    return { $$typeof: M, render: r };
  }, v.isValidElement = le, v.lazy = function(r) {
    return { $$typeof: L, _payload: { _status: -1, _result: r }, _init: te };
  }, v.memo = function(r, i) {
    return { $$typeof: N, type: r, compare: i === void 0 ? null : i };
  }, v.startTransition = function(r) {
    var i = ae.transition;
    ae.transition = {};
    try {
      r();
    } finally {
      ae.transition = i;
    }
  }, v.unstable_act = function() {
    throw Error("act(...) is not supported in production builds of React.");
  }, v.useCallback = function(r, i) {
    return c.current.useCallback(r, i);
  }, v.useContext = function(r) {
    return c.current.useContext(r);
  }, v.useDebugValue = function() {
  }, v.useDeferredValue = function(r) {
    return c.current.useDeferredValue(r);
  }, v.useEffect = function(r, i) {
    return c.current.useEffect(r, i);
  }, v.useId = function() {
    return c.current.useId();
  }, v.useImperativeHandle = function(r, i, p) {
    return c.current.useImperativeHandle(r, i, p);
  }, v.useInsertionEffect = function(r, i) {
    return c.current.useInsertionEffect(r, i);
  }, v.useLayoutEffect = function(r, i) {
    return c.current.useLayoutEffect(r, i);
  }, v.useMemo = function(r, i) {
    return c.current.useMemo(r, i);
  }, v.useReducer = function(r, i, p) {
    return c.current.useReducer(r, i, p);
  }, v.useRef = function(r) {
    return c.current.useRef(r);
  }, v.useState = function(r) {
    return c.current.useState(r);
  }, v.useSyncExternalStore = function(r, i, p) {
    return c.current.useSyncExternalStore(r, i, p);
  }, v.useTransition = function() {
    return c.current.useTransition();
  }, v.version = "18.2.0", v;
}
var Te = { exports: {} };
/**
 * @license React
 * react.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var xt;
function tn() {
  return xt || (xt = 1, function(f, u) {
    process.env.NODE_ENV !== "production" && function() {
      typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ < "u" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart == "function" && __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(new Error());
      var k = "18.2.0", j = Symbol.for("react.element"), T = Symbol.for("react.portal"), P = Symbol.for("react.fragment"), A = Symbol.for("react.strict_mode"), M = Symbol.for("react.profiler"), H = Symbol.for("react.provider"), N = Symbol.for("react.context"), L = Symbol.for("react.forward_ref"), G = Symbol.for("react.suspense"), Z = Symbol.for("react.suspense_list"), I = Symbol.for("react.memo"), x = Symbol.for("react.lazy"), q = Symbol.for("react.offscreen"), z = Symbol.iterator, F = "@@iterator";
      function W(e) {
        if (e === null || typeof e != "object")
          return null;
        var t = z && e[z] || e[F];
        return typeof t == "function" ? t : null;
      }
      var J = {
        current: null
      }, X = {
        transition: null
      }, $ = {
        current: null,
        isBatchingLegacy: !1,
        didScheduleLegacyUpdate: !1
      }, B = {
        current: null
      }, ee = {}, ne = null;
      function ve(e) {
        ne = e;
      }
      ee.setExtraStackFrame = function(e) {
        ne = e;
      }, ee.getCurrentStack = null, ee.getStackAddendum = function() {
        var e = "";
        ne && (e += ne);
        var t = ee.getCurrentStack;
        return t && (e += t() || ""), e;
      };
      var le = !1, Ae = !1, he = !1, ce = !1, oe = !1, K = {
        ReactCurrentDispatcher: J,
        ReactCurrentBatchConfig: X,
        ReactCurrentOwner: B
      };
      K.ReactDebugCurrentFrame = ee, K.ReactCurrentActQueue = $;
      function te(e) {
        {
          for (var t = arguments.length, n = new Array(t > 1 ? t - 1 : 0), a = 1; a < t; a++)
            n[a - 1] = arguments[a];
          ae("warn", e, n);
        }
      }
      function c(e) {
        {
          for (var t = arguments.length, n = new Array(t > 1 ? t - 1 : 0), a = 1; a < t; a++)
            n[a - 1] = arguments[a];
          ae("error", e, n);
        }
      }
      function ae(e, t, n) {
        {
          var a = K.ReactDebugCurrentFrame, o = a.getStackAddendum();
          o !== "" && (t += "%s", n = n.concat([o]));
          var l = n.map(function(s) {
            return String(s);
          });
          l.unshift("Warning: " + t), Function.prototype.apply.call(console[e], console, l);
        }
      }
      var ye = {};
      function r(e, t) {
        {
          var n = e.constructor, a = n && (n.displayName || n.name) || "ReactClass", o = a + "." + t;
          if (ye[o])
            return;
          c("Can't call %s on a component that is not yet mounted. This is a no-op, but it might indicate a bug in your application. Instead, assign to `this.state` directly or define a `state = {};` class property with the desired state in the %s component.", t, a), ye[o] = !0;
        }
      }
      var i = {
        isMounted: function(e) {
          return !1;
        },
        enqueueForceUpdate: function(e, t, n) {
          r(e, "forceUpdate");
        },
        enqueueReplaceState: function(e, t, n, a) {
          r(e, "replaceState");
        },
        enqueueSetState: function(e, t, n, a) {
          r(e, "setState");
        }
      }, p = Object.assign, m = {};
      Object.freeze(m);
      function h(e, t, n) {
        this.props = e, this.context = t, this.refs = m, this.updater = n || i;
      }
      h.prototype.isReactComponent = {}, h.prototype.setState = function(e, t) {
        if (typeof e != "object" && typeof e != "function" && e != null)
          throw new Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");
        this.updater.enqueueSetState(this, e, t, "setState");
      }, h.prototype.forceUpdate = function(e) {
        this.updater.enqueueForceUpdate(this, e, "forceUpdate");
      };
      {
        var g = {
          isMounted: ["isMounted", "Instead, make sure to clean up subscriptions and pending requests in componentWillUnmount to prevent memory leaks."],
          replaceState: ["replaceState", "Refactor your code to use setState instead (see https://github.com/facebook/react/issues/3236)."]
        }, S = function(e, t) {
          Object.defineProperty(h.prototype, e, {
            get: function() {
              te("%s(...) is deprecated in plain JavaScript React classes. %s", t[0], t[1]);
            }
          });
        };
        for (var b in g)
          g.hasOwnProperty(b) && S(b, g[b]);
      }
      function w() {
      }
      w.prototype = h.prototype;
      function U(e, t, n) {
        this.props = e, this.context = t, this.refs = m, this.updater = n || i;
      }
      var xe = U.prototype = new w();
      xe.constructor = U, p(xe, h.prototype), xe.isPureReactComponent = !0;
      function Mt() {
        var e = {
          current: null
        };
        return Object.seal(e), e;
      }
      var Lt = Array.isArray;
      function me(e) {
        return Lt(e);
      }
      function Ft(e) {
        {
          var t = typeof Symbol == "function" && Symbol.toStringTag, n = t && e[Symbol.toStringTag] || e.constructor.name || "Object";
          return n;
        }
      }
      function Nt(e) {
        try {
          return He(e), !1;
        } catch {
          return !0;
        }
      }
      function He(e) {
        return "" + e;
      }
      function _e(e) {
        if (Nt(e))
          return c("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", Ft(e)), He(e);
      }
      function Ut(e, t, n) {
        var a = e.displayName;
        if (a)
          return a;
        var o = t.displayName || t.name || "";
        return o !== "" ? n + "(" + o + ")" : n;
      }
      function Ge(e) {
        return e.displayName || "Context";
      }
      function re(e) {
        if (e == null)
          return null;
        if (typeof e.tag == "number" && c("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof e == "function")
          return e.displayName || e.name || null;
        if (typeof e == "string")
          return e;
        switch (e) {
          case P:
            return "Fragment";
          case T:
            return "Portal";
          case M:
            return "Profiler";
          case A:
            return "StrictMode";
          case G:
            return "Suspense";
          case Z:
            return "SuspenseList";
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case N:
              var t = e;
              return Ge(t) + ".Consumer";
            case H:
              var n = e;
              return Ge(n._context) + ".Provider";
            case L:
              return Ut(e, e.render, "ForwardRef");
            case I:
              var a = e.displayName || null;
              return a !== null ? a : re(e.type) || "Memo";
            case x: {
              var o = e, l = o._payload, s = o._init;
              try {
                return re(s(l));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      var fe = Object.prototype.hasOwnProperty, Ke = {
        key: !0,
        ref: !0,
        __self: !0,
        __source: !0
      }, Qe, Je, $e;
      $e = {};
      function Xe(e) {
        if (fe.call(e, "ref")) {
          var t = Object.getOwnPropertyDescriptor(e, "ref").get;
          if (t && t.isReactWarning)
            return !1;
        }
        return e.ref !== void 0;
      }
      function Ze(e) {
        if (fe.call(e, "key")) {
          var t = Object.getOwnPropertyDescriptor(e, "key").get;
          if (t && t.isReactWarning)
            return !1;
        }
        return e.key !== void 0;
      }
      function Vt(e, t) {
        var n = function() {
          Qe || (Qe = !0, c("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", t));
        };
        n.isReactWarning = !0, Object.defineProperty(e, "key", {
          get: n,
          configurable: !0
        });
      }
      function Wt(e, t) {
        var n = function() {
          Je || (Je = !0, c("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", t));
        };
        n.isReactWarning = !0, Object.defineProperty(e, "ref", {
          get: n,
          configurable: !0
        });
      }
      function Yt(e) {
        if (typeof e.ref == "string" && B.current && e.__self && B.current.stateNode !== e.__self) {
          var t = re(B.current.type);
          $e[t] || (c('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', t, e.ref), $e[t] = !0);
        }
      }
      var Ie = function(e, t, n, a, o, l, s) {
        var d = {
          $$typeof: j,
          type: e,
          key: t,
          ref: n,
          props: s,
          _owner: l
        };
        return d._store = {}, Object.defineProperty(d._store, "validated", {
          configurable: !1,
          enumerable: !1,
          writable: !0,
          value: !1
        }), Object.defineProperty(d, "_self", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: a
        }), Object.defineProperty(d, "_source", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: o
        }), Object.freeze && (Object.freeze(d.props), Object.freeze(d)), d;
      };
      function qt(e, t, n) {
        var a, o = {}, l = null, s = null, d = null, y = null;
        if (t != null) {
          Xe(t) && (s = t.ref, Yt(t)), Ze(t) && (_e(t.key), l = "" + t.key), d = t.__self === void 0 ? null : t.__self, y = t.__source === void 0 ? null : t.__source;
          for (a in t)
            fe.call(t, a) && !Ke.hasOwnProperty(a) && (o[a] = t[a]);
        }
        var _ = arguments.length - 2;
        if (_ === 1)
          o.children = n;
        else if (_ > 1) {
          for (var E = Array(_), R = 0; R < _; R++)
            E[R] = arguments[R + 2];
          Object.freeze && Object.freeze(E), o.children = E;
        }
        if (e && e.defaultProps) {
          var C = e.defaultProps;
          for (a in C)
            o[a] === void 0 && (o[a] = C[a]);
        }
        if (l || s) {
          var O = typeof e == "function" ? e.displayName || e.name || "Unknown" : e;
          l && Vt(o, O), s && Wt(o, O);
        }
        return Ie(e, l, s, d, y, B.current, o);
      }
      function zt(e, t) {
        var n = Ie(e.type, t, e.ref, e._self, e._source, e._owner, e.props);
        return n;
      }
      function Bt(e, t, n) {
        if (e == null)
          throw new Error("React.cloneElement(...): The argument must be a React element, but you passed " + e + ".");
        var a, o = p({}, e.props), l = e.key, s = e.ref, d = e._self, y = e._source, _ = e._owner;
        if (t != null) {
          Xe(t) && (s = t.ref, _ = B.current), Ze(t) && (_e(t.key), l = "" + t.key);
          var E;
          e.type && e.type.defaultProps && (E = e.type.defaultProps);
          for (a in t)
            fe.call(t, a) && !Ke.hasOwnProperty(a) && (t[a] === void 0 && E !== void 0 ? o[a] = E[a] : o[a] = t[a]);
        }
        var R = arguments.length - 2;
        if (R === 1)
          o.children = n;
        else if (R > 1) {
          for (var C = Array(R), O = 0; O < R; O++)
            C[O] = arguments[O + 2];
          o.children = C;
        }
        return Ie(e.type, l, s, d, y, _, o);
      }
      function ie(e) {
        return typeof e == "object" && e !== null && e.$$typeof === j;
      }
      var et = ".", Ht = ":";
      function Gt(e) {
        var t = /[=:]/g, n = {
          "=": "=0",
          ":": "=2"
        }, a = e.replace(t, function(o) {
          return n[o];
        });
        return "$" + a;
      }
      var tt = !1, Kt = /\/+/g;
      function rt(e) {
        return e.replace(Kt, "$&/");
      }
      function De(e, t) {
        return typeof e == "object" && e !== null && e.key != null ? (_e(e.key), Gt("" + e.key)) : t.toString(36);
      }
      function ge(e, t, n, a, o) {
        var l = typeof e;
        (l === "undefined" || l === "boolean") && (e = null);
        var s = !1;
        if (e === null)
          s = !0;
        else
          switch (l) {
            case "string":
            case "number":
              s = !0;
              break;
            case "object":
              switch (e.$$typeof) {
                case j:
                case T:
                  s = !0;
              }
          }
        if (s) {
          var d = e, y = o(d), _ = a === "" ? et + De(d, 0) : a;
          if (me(y)) {
            var E = "";
            _ != null && (E = rt(_) + "/"), ge(y, t, E, "", function(Wr) {
              return Wr;
            });
          } else
            y != null && (ie(y) && (y.key && (!d || d.key !== y.key) && _e(y.key), y = zt(
              y,
              n + (y.key && (!d || d.key !== y.key) ? rt("" + y.key) + "/" : "") + _
            )), t.push(y));
          return 1;
        }
        var R, C, O = 0, D = a === "" ? et : a + Ht;
        if (me(e))
          for (var ke = 0; ke < e.length; ke++)
            R = e[ke], C = D + De(R, ke), O += ge(R, t, n, C, o);
        else {
          var qe = W(e);
          if (typeof qe == "function") {
            var Ot = e;
            qe === Ot.entries && (tt || te("Using Maps as children is not supported. Use an array of keyed ReactElements instead."), tt = !0);
            for (var Ur = qe.call(Ot), kt, Vr = 0; !(kt = Ur.next()).done; )
              R = kt.value, C = D + De(R, Vr++), O += ge(R, t, n, C, o);
          } else if (l === "object") {
            var Tt = String(e);
            throw new Error("Objects are not valid as a React child (found: " + (Tt === "[object Object]" ? "object with keys {" + Object.keys(e).join(", ") + "}" : Tt) + "). If you meant to render a collection of children, use an array instead.");
          }
        }
        return O;
      }
      function be(e, t, n) {
        if (e == null)
          return e;
        var a = [], o = 0;
        return ge(e, a, "", "", function(l) {
          return t.call(n, l, o++);
        }), a;
      }
      function Qt(e) {
        var t = 0;
        return be(e, function() {
          t++;
        }), t;
      }
      function Jt(e, t, n) {
        be(e, function() {
          t.apply(this, arguments);
        }, n);
      }
      function Xt(e) {
        return be(e, function(t) {
          return t;
        }) || [];
      }
      function Zt(e) {
        if (!ie(e))
          throw new Error("React.Children.only expected to receive a single React element child.");
        return e;
      }
      function er(e) {
        var t = {
          $$typeof: N,
          _currentValue: e,
          _currentValue2: e,
          _threadCount: 0,
          Provider: null,
          Consumer: null,
          _defaultValue: null,
          _globalName: null
        };
        t.Provider = {
          $$typeof: H,
          _context: t
        };
        var n = !1, a = !1, o = !1;
        {
          var l = {
            $$typeof: N,
            _context: t
          };
          Object.defineProperties(l, {
            Provider: {
              get: function() {
                return a || (a = !0, c("Rendering <Context.Consumer.Provider> is not supported and will be removed in a future major release. Did you mean to render <Context.Provider> instead?")), t.Provider;
              },
              set: function(s) {
                t.Provider = s;
              }
            },
            _currentValue: {
              get: function() {
                return t._currentValue;
              },
              set: function(s) {
                t._currentValue = s;
              }
            },
            _currentValue2: {
              get: function() {
                return t._currentValue2;
              },
              set: function(s) {
                t._currentValue2 = s;
              }
            },
            _threadCount: {
              get: function() {
                return t._threadCount;
              },
              set: function(s) {
                t._threadCount = s;
              }
            },
            Consumer: {
              get: function() {
                return n || (n = !0, c("Rendering <Context.Consumer.Consumer> is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?")), t.Consumer;
              }
            },
            displayName: {
              get: function() {
                return t.displayName;
              },
              set: function(s) {
                o || (te("Setting `displayName` on Context.Consumer has no effect. You should set it directly on the context with Context.displayName = '%s'.", s), o = !0);
              }
            }
          }), t.Consumer = l;
        }
        return t._currentRenderer = null, t._currentRenderer2 = null, t;
      }
      var de = -1, Me = 0, nt = 1, tr = 2;
      function rr(e) {
        if (e._status === de) {
          var t = e._result, n = t();
          if (n.then(function(l) {
            if (e._status === Me || e._status === de) {
              var s = e;
              s._status = nt, s._result = l;
            }
          }, function(l) {
            if (e._status === Me || e._status === de) {
              var s = e;
              s._status = tr, s._result = l;
            }
          }), e._status === de) {
            var a = e;
            a._status = Me, a._result = n;
          }
        }
        if (e._status === nt) {
          var o = e._result;
          return o === void 0 && c(`lazy: Expected the result of a dynamic import() call. Instead received: %s

Your code should look like: 
  const MyComponent = lazy(() => import('./MyComponent'))

Did you accidentally put curly braces around the import?`, o), "default" in o || c(`lazy: Expected the result of a dynamic import() call. Instead received: %s

Your code should look like: 
  const MyComponent = lazy(() => import('./MyComponent'))`, o), o.default;
        } else
          throw e._result;
      }
      function nr(e) {
        var t = {
          _status: de,
          _result: e
        }, n = {
          $$typeof: x,
          _payload: t,
          _init: rr
        };
        {
          var a, o;
          Object.defineProperties(n, {
            defaultProps: {
              configurable: !0,
              get: function() {
                return a;
              },
              set: function(l) {
                c("React.lazy(...): It is not supported to assign `defaultProps` to a lazy component import. Either specify them where the component is defined, or create a wrapping component around it."), a = l, Object.defineProperty(n, "defaultProps", {
                  enumerable: !0
                });
              }
            },
            propTypes: {
              configurable: !0,
              get: function() {
                return o;
              },
              set: function(l) {
                c("React.lazy(...): It is not supported to assign `propTypes` to a lazy component import. Either specify them where the component is defined, or create a wrapping component around it."), o = l, Object.defineProperty(n, "propTypes", {
                  enumerable: !0
                });
              }
            }
          });
        }
        return n;
      }
      function ar(e) {
        e != null && e.$$typeof === I ? c("forwardRef requires a render function but received a `memo` component. Instead of forwardRef(memo(...)), use memo(forwardRef(...)).") : typeof e != "function" ? c("forwardRef requires a render function but was given %s.", e === null ? "null" : typeof e) : e.length !== 0 && e.length !== 2 && c("forwardRef render functions accept exactly two parameters: props and ref. %s", e.length === 1 ? "Did you forget to use the ref parameter?" : "Any additional parameter will be undefined."), e != null && (e.defaultProps != null || e.propTypes != null) && c("forwardRef render functions do not support propTypes or defaultProps. Did you accidentally pass a React component?");
        var t = {
          $$typeof: L,
          render: e
        };
        {
          var n;
          Object.defineProperty(t, "displayName", {
            enumerable: !1,
            configurable: !0,
            get: function() {
              return n;
            },
            set: function(a) {
              n = a, !e.name && !e.displayName && (e.displayName = a);
            }
          });
        }
        return t;
      }
      var at;
      at = Symbol.for("react.module.reference");
      function ot(e) {
        return !!(typeof e == "string" || typeof e == "function" || e === P || e === M || oe || e === A || e === G || e === Z || ce || e === q || le || Ae || he || typeof e == "object" && e !== null && (e.$$typeof === x || e.$$typeof === I || e.$$typeof === H || e.$$typeof === N || e.$$typeof === L || e.$$typeof === at || e.getModuleId !== void 0));
      }
      function or(e, t) {
        ot(e) || c("memo: The first argument must be a component. Instead received: %s", e === null ? "null" : typeof e);
        var n = {
          $$typeof: I,
          type: e,
          compare: t === void 0 ? null : t
        };
        {
          var a;
          Object.defineProperty(n, "displayName", {
            enumerable: !1,
            configurable: !0,
            get: function() {
              return a;
            },
            set: function(o) {
              a = o, !e.name && !e.displayName && (e.displayName = o);
            }
          });
        }
        return n;
      }
      function V() {
        var e = J.current;
        return e === null && c(`Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:
1. You might have mismatching versions of React and the renderer (such as React DOM)
2. You might be breaking the Rules of Hooks
3. You might have more than one copy of React in the same app
See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.`), e;
      }
      function ir(e) {
        var t = V();
        if (e._context !== void 0) {
          var n = e._context;
          n.Consumer === e ? c("Calling useContext(Context.Consumer) is not supported, may cause bugs, and will be removed in a future major release. Did you mean to call useContext(Context) instead?") : n.Provider === e && c("Calling useContext(Context.Provider) is not supported. Did you mean to call useContext(Context) instead?");
        }
        return t.useContext(e);
      }
      function ur(e) {
        var t = V();
        return t.useState(e);
      }
      function sr(e, t, n) {
        var a = V();
        return a.useReducer(e, t, n);
      }
      function lr(e) {
        var t = V();
        return t.useRef(e);
      }
      function cr(e, t) {
        var n = V();
        return n.useEffect(e, t);
      }
      function fr(e, t) {
        var n = V();
        return n.useInsertionEffect(e, t);
      }
      function dr(e, t) {
        var n = V();
        return n.useLayoutEffect(e, t);
      }
      function pr(e, t) {
        var n = V();
        return n.useCallback(e, t);
      }
      function vr(e, t) {
        var n = V();
        return n.useMemo(e, t);
      }
      function hr(e, t, n) {
        var a = V();
        return a.useImperativeHandle(e, t, n);
      }
      function yr(e, t) {
        {
          var n = V();
          return n.useDebugValue(e, t);
        }
      }
      function mr() {
        var e = V();
        return e.useTransition();
      }
      function _r(e) {
        var t = V();
        return t.useDeferredValue(e);
      }
      function gr() {
        var e = V();
        return e.useId();
      }
      function br(e, t, n) {
        var a = V();
        return a.useSyncExternalStore(e, t, n);
      }
      var pe = 0, it, ut, st, lt, ct, ft, dt;
      function pt() {
      }
      pt.__reactDisabledLog = !0;
      function wr() {
        {
          if (pe === 0) {
            it = console.log, ut = console.info, st = console.warn, lt = console.error, ct = console.group, ft = console.groupCollapsed, dt = console.groupEnd;
            var e = {
              configurable: !0,
              enumerable: !0,
              value: pt,
              writable: !0
            };
            Object.defineProperties(console, {
              info: e,
              log: e,
              warn: e,
              error: e,
              group: e,
              groupCollapsed: e,
              groupEnd: e
            });
          }
          pe++;
        }
      }
      function Er() {
        {
          if (pe--, pe === 0) {
            var e = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: p({}, e, {
                value: it
              }),
              info: p({}, e, {
                value: ut
              }),
              warn: p({}, e, {
                value: st
              }),
              error: p({}, e, {
                value: lt
              }),
              group: p({}, e, {
                value: ct
              }),
              groupCollapsed: p({}, e, {
                value: ft
              }),
              groupEnd: p({}, e, {
                value: dt
              })
            });
          }
          pe < 0 && c("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var Le = K.ReactCurrentDispatcher, Fe;
      function we(e, t, n) {
        {
          if (Fe === void 0)
            try {
              throw Error();
            } catch (o) {
              var a = o.stack.trim().match(/\n( *(at )?)/);
              Fe = a && a[1] || "";
            }
          return `
` + Fe + e;
        }
      }
      var Ne = !1, Ee;
      {
        var Rr = typeof WeakMap == "function" ? WeakMap : Map;
        Ee = new Rr();
      }
      function vt(e, t) {
        if (!e || Ne)
          return "";
        {
          var n = Ee.get(e);
          if (n !== void 0)
            return n;
        }
        var a;
        Ne = !0;
        var o = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var l;
        l = Le.current, Le.current = null, wr();
        try {
          if (t) {
            var s = function() {
              throw Error();
            };
            if (Object.defineProperty(s.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(s, []);
              } catch (D) {
                a = D;
              }
              Reflect.construct(e, [], s);
            } else {
              try {
                s.call();
              } catch (D) {
                a = D;
              }
              e.call(s.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (D) {
              a = D;
            }
            e();
          }
        } catch (D) {
          if (D && a && typeof D.stack == "string") {
            for (var d = D.stack.split(`
`), y = a.stack.split(`
`), _ = d.length - 1, E = y.length - 1; _ >= 1 && E >= 0 && d[_] !== y[E]; )
              E--;
            for (; _ >= 1 && E >= 0; _--, E--)
              if (d[_] !== y[E]) {
                if (_ !== 1 || E !== 1)
                  do
                    if (_--, E--, E < 0 || d[_] !== y[E]) {
                      var R = `
` + d[_].replace(" at new ", " at ");
                      return e.displayName && R.includes("<anonymous>") && (R = R.replace("<anonymous>", e.displayName)), typeof e == "function" && Ee.set(e, R), R;
                    }
                  while (_ >= 1 && E >= 0);
                break;
              }
          }
        } finally {
          Ne = !1, Le.current = l, Er(), Error.prepareStackTrace = o;
        }
        var C = e ? e.displayName || e.name : "", O = C ? we(C) : "";
        return typeof e == "function" && Ee.set(e, O), O;
      }
      function Cr(e, t, n) {
        return vt(e, !1);
      }
      function Sr(e) {
        var t = e.prototype;
        return !!(t && t.isReactComponent);
      }
      function Re(e, t, n) {
        if (e == null)
          return "";
        if (typeof e == "function")
          return vt(e, Sr(e));
        if (typeof e == "string")
          return we(e);
        switch (e) {
          case G:
            return we("Suspense");
          case Z:
            return we("SuspenseList");
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case L:
              return Cr(e.render);
            case I:
              return Re(e.type, t, n);
            case x: {
              var a = e, o = a._payload, l = a._init;
              try {
                return Re(l(o), t, n);
              } catch {
              }
            }
          }
        return "";
      }
      var ht = {}, yt = K.ReactDebugCurrentFrame;
      function Ce(e) {
        if (e) {
          var t = e._owner, n = Re(e.type, e._source, t ? t.type : null);
          yt.setExtraStackFrame(n);
        } else
          yt.setExtraStackFrame(null);
      }
      function Or(e, t, n, a, o) {
        {
          var l = Function.call.bind(fe);
          for (var s in e)
            if (l(e, s)) {
              var d = void 0;
              try {
                if (typeof e[s] != "function") {
                  var y = Error((a || "React class") + ": " + n + " type `" + s + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof e[s] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw y.name = "Invariant Violation", y;
                }
                d = e[s](t, s, a, n, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (_) {
                d = _;
              }
              d && !(d instanceof Error) && (Ce(o), c("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", a || "React class", n, s, typeof d), Ce(null)), d instanceof Error && !(d.message in ht) && (ht[d.message] = !0, Ce(o), c("Failed %s type: %s", n, d.message), Ce(null));
            }
        }
      }
      function ue(e) {
        if (e) {
          var t = e._owner, n = Re(e.type, e._source, t ? t.type : null);
          ve(n);
        } else
          ve(null);
      }
      var Ue;
      Ue = !1;
      function mt() {
        if (B.current) {
          var e = re(B.current.type);
          if (e)
            return `

Check the render method of \`` + e + "`.";
        }
        return "";
      }
      function kr(e) {
        if (e !== void 0) {
          var t = e.fileName.replace(/^.*[\\\/]/, ""), n = e.lineNumber;
          return `

Check your code at ` + t + ":" + n + ".";
        }
        return "";
      }
      function Tr(e) {
        return e != null ? kr(e.__source) : "";
      }
      var _t = {};
      function Pr(e) {
        var t = mt();
        if (!t) {
          var n = typeof e == "string" ? e : e.displayName || e.name;
          n && (t = `

Check the top-level render call using <` + n + ">.");
        }
        return t;
      }
      function gt(e, t) {
        if (!(!e._store || e._store.validated || e.key != null)) {
          e._store.validated = !0;
          var n = Pr(t);
          if (!_t[n]) {
            _t[n] = !0;
            var a = "";
            e && e._owner && e._owner !== B.current && (a = " It was passed a child from " + re(e._owner.type) + "."), ue(e), c('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', n, a), ue(null);
          }
        }
      }
      function bt(e, t) {
        if (typeof e == "object") {
          if (me(e))
            for (var n = 0; n < e.length; n++) {
              var a = e[n];
              ie(a) && gt(a, t);
            }
          else if (ie(e))
            e._store && (e._store.validated = !0);
          else if (e) {
            var o = W(e);
            if (typeof o == "function" && o !== e.entries)
              for (var l = o.call(e), s; !(s = l.next()).done; )
                ie(s.value) && gt(s.value, t);
          }
        }
      }
      function wt(e) {
        {
          var t = e.type;
          if (t == null || typeof t == "string")
            return;
          var n;
          if (typeof t == "function")
            n = t.propTypes;
          else if (typeof t == "object" && (t.$$typeof === L || t.$$typeof === I))
            n = t.propTypes;
          else
            return;
          if (n) {
            var a = re(t);
            Or(n, e.props, "prop", a, e);
          } else if (t.PropTypes !== void 0 && !Ue) {
            Ue = !0;
            var o = re(t);
            c("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", o || "Unknown");
          }
          typeof t.getDefaultProps == "function" && !t.getDefaultProps.isReactClassApproved && c("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
        }
      }
      function jr(e) {
        {
          for (var t = Object.keys(e.props), n = 0; n < t.length; n++) {
            var a = t[n];
            if (a !== "children" && a !== "key") {
              ue(e), c("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", a), ue(null);
              break;
            }
          }
          e.ref !== null && (ue(e), c("Invalid attribute `ref` supplied to `React.Fragment`."), ue(null));
        }
      }
      function Et(e, t, n) {
        var a = ot(e);
        if (!a) {
          var o = "";
          (e === void 0 || typeof e == "object" && e !== null && Object.keys(e).length === 0) && (o += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var l = Tr(t);
          l ? o += l : o += mt();
          var s;
          e === null ? s = "null" : me(e) ? s = "array" : e !== void 0 && e.$$typeof === j ? (s = "<" + (re(e.type) || "Unknown") + " />", o = " Did you accidentally export a JSX literal instead of a component?") : s = typeof e, c("React.createElement: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", s, o);
        }
        var d = qt.apply(this, arguments);
        if (d == null)
          return d;
        if (a)
          for (var y = 2; y < arguments.length; y++)
            bt(arguments[y], e);
        return e === P ? jr(d) : wt(d), d;
      }
      var Rt = !1;
      function Ar(e) {
        var t = Et.bind(null, e);
        return t.type = e, Rt || (Rt = !0, te("React.createFactory() is deprecated and will be removed in a future major release. Consider using JSX or use React.createElement() directly instead.")), Object.defineProperty(t, "type", {
          enumerable: !1,
          get: function() {
            return te("Factory.type is deprecated. Access the class directly before passing it to createFactory."), Object.defineProperty(this, "type", {
              value: e
            }), e;
          }
        }), t;
      }
      function xr(e, t, n) {
        for (var a = Bt.apply(this, arguments), o = 2; o < arguments.length; o++)
          bt(arguments[o], a.type);
        return wt(a), a;
      }
      function $r(e, t) {
        var n = X.transition;
        X.transition = {};
        var a = X.transition;
        X.transition._updatedFibers = /* @__PURE__ */ new Set();
        try {
          e();
        } finally {
          if (X.transition = n, n === null && a._updatedFibers) {
            var o = a._updatedFibers.size;
            o > 10 && te("Detected a large number of updates inside startTransition. If this is due to a subscription please re-write it to use React provided hooks. Otherwise concurrent mode guarantees are off the table."), a._updatedFibers.clear();
          }
        }
      }
      var Ct = !1, Se = null;
      function Ir(e) {
        if (Se === null)
          try {
            var t = ("require" + Math.random()).slice(0, 7), n = f && f[t];
            Se = n.call(f, "timers").setImmediate;
          } catch {
            Se = function(o) {
              Ct === !1 && (Ct = !0, typeof MessageChannel > "u" && c("This browser does not have a MessageChannel implementation, so enqueuing tasks via await act(async () => ...) will fail. Please file an issue at https://github.com/facebook/react/issues if you encounter this warning."));
              var l = new MessageChannel();
              l.port1.onmessage = o, l.port2.postMessage(void 0);
            };
          }
        return Se(e);
      }
      var se = 0, St = !1;
      function Dr(e) {
        {
          var t = se;
          se++, $.current === null && ($.current = []);
          var n = $.isBatchingLegacy, a;
          try {
            if ($.isBatchingLegacy = !0, a = e(), !n && $.didScheduleLegacyUpdate) {
              var o = $.current;
              o !== null && ($.didScheduleLegacyUpdate = !1, Ye(o));
            }
          } catch (C) {
            throw Oe(t), C;
          } finally {
            $.isBatchingLegacy = n;
          }
          if (a !== null && typeof a == "object" && typeof a.then == "function") {
            var l = a, s = !1, d = {
              then: function(C, O) {
                s = !0, l.then(function(D) {
                  Oe(t), se === 0 ? Ve(D, C, O) : C(D);
                }, function(D) {
                  Oe(t), O(D);
                });
              }
            };
            return !St && typeof Promise < "u" && Promise.resolve().then(function() {
            }).then(function() {
              s || (St = !0, c("You called act(async () => ...) without await. This could lead to unexpected testing behaviour, interleaving multiple act calls and mixing their scopes. You should - await act(async () => ...);"));
            }), d;
          } else {
            var y = a;
            if (Oe(t), se === 0) {
              var _ = $.current;
              _ !== null && (Ye(_), $.current = null);
              var E = {
                then: function(C, O) {
                  $.current === null ? ($.current = [], Ve(y, C, O)) : C(y);
                }
              };
              return E;
            } else {
              var R = {
                then: function(C, O) {
                  C(y);
                }
              };
              return R;
            }
          }
        }
      }
      function Oe(e) {
        e !== se - 1 && c("You seem to have overlapping act() calls, this is not supported. Be sure to await previous act() calls before making a new one. "), se = e;
      }
      function Ve(e, t, n) {
        {
          var a = $.current;
          if (a !== null)
            try {
              Ye(a), Ir(function() {
                a.length === 0 ? ($.current = null, t(e)) : Ve(e, t, n);
              });
            } catch (o) {
              n(o);
            }
          else
            t(e);
        }
      }
      var We = !1;
      function Ye(e) {
        if (!We) {
          We = !0;
          var t = 0;
          try {
            for (; t < e.length; t++) {
              var n = e[t];
              do
                n = n(!0);
              while (n !== null);
            }
            e.length = 0;
          } catch (a) {
            throw e = e.slice(t + 1), a;
          } finally {
            We = !1;
          }
        }
      }
      var Mr = Et, Lr = xr, Fr = Ar, Nr = {
        map: be,
        forEach: Jt,
        count: Qt,
        toArray: Xt,
        only: Zt
      };
      u.Children = Nr, u.Component = h, u.Fragment = P, u.Profiler = M, u.PureComponent = U, u.StrictMode = A, u.Suspense = G, u.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = K, u.cloneElement = Lr, u.createContext = er, u.createElement = Mr, u.createFactory = Fr, u.createRef = Mt, u.forwardRef = ar, u.isValidElement = ie, u.lazy = nr, u.memo = or, u.startTransition = $r, u.unstable_act = Dr, u.useCallback = pr, u.useContext = ir, u.useDebugValue = yr, u.useDeferredValue = _r, u.useEffect = cr, u.useId = gr, u.useImperativeHandle = hr, u.useInsertionEffect = fr, u.useLayoutEffect = dr, u.useMemo = vr, u.useReducer = sr, u.useRef = lr, u.useState = ur, u.useSyncExternalStore = br, u.useTransition = mr, u.version = k, typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ < "u" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop == "function" && __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(new Error());
    }();
  }(Te, Te.exports)), Te.exports;
}
(function(f) {
  process.env.NODE_ENV === "production" ? f.exports = en() : f.exports = tn();
})(Dt);
const rn = /* @__PURE__ */ Zr(Dt.exports);
var nn = Object.defineProperty, an = Object.getOwnPropertyDescriptor, Q = (f, u, k, j) => {
  for (var T = j > 1 ? void 0 : j ? an(u, k) : u, P = f.length - 1, A; P >= 0; P--)
    (A = f[P]) && (T = (j ? A(u, k, T) : A(T)) || T);
  return j && T && nn(u, k, T), T;
};
let Y = class extends Yr {
  constructor() {
    super(), this.uid = "", this.settings = [], this.options = {}, this.fullScreen = !1, this.viewr_opacity = !1, this.show_buttons = !1, this.show_loaders = !0, this._sendMessage = () => {
      this._showModel(), this.settings && this.settings.forEach((f) => {
        var u;
        (u = this.api_iframe.contentWindow) == null || u.postMessage(
          {
            type: "api.request",
            instanceId: "1",
            requestId: f.name,
            member: f.name,
            arguments: f.arguments
          },
          "https://sketchfab.com"
        );
      });
    }, this._showModel = () => {
      this.viewr_opacity = !0, this.show_loaders = !1, this.show_buttons = !0;
    }, this._handleMessageEvent = (f) => {
      const { data: u } = f, k = {
        detail: { data: u },
        bubbles: !0,
        composed: !0
      };
      u.results[0] === "viewerready" && this._sendMessage(), u.type === "api.request.result" && this.dispatchEvent(new CustomEvent("onResponse", k));
    }, this.uid;
  }
  render() {
    return Pe` <div
      class=${`main-container ${this.fullScreen ? "full-screen" : ""}`}
    >
      ${this.show_loaders ? Pe`<slot name="loader">${Kr()}</slot>` : null}

      <iframe
        src=${this._build_url()}
        id="api_iframe"
        class=${!this.viewr_opacity && "hidden"}
        allow="autoplay; fullscreen; xr-spatial-tracking"
        xr-spatial-tracking
        execution-while-out-of-viewport
        execution-while-not-rendered
        web-share
        allowfullscreen
        mozallowfullscreen="true"
        webkitallowfullscreen="true"
        @load=${() => this._init_message()}
      ></iframe>
      ${this.show_buttons ? Pe`<slot name="button"></slot>` : null}
    </div>`;
  }
  firstUpdated() {
    window.addEventListener(
      "message",
      (f) => this._handleMessageEvent(f)
    );
  }
  _init_message() {
    var f;
    (f = this.api_iframe.contentWindow) == null || f.postMessage(
      { type: "api.initialize", requestId: 0, name: "1.12.1", instanceId: "1" },
      "https://sketchfab.com"
    );
  }
  _build_url() {
    if (typeof this.uid != "string")
      throw new Error("model uid must be a string");
    this.options && Object.assign(ze, this.options);
    const f = new URL(this.uid + Hr, Br);
    return Object.keys(Pt).forEach((u) => {
      f.searchParams.append(u, Pt[u]);
    }), Object.keys(ze).forEach((u) => {
      f.searchParams.append(u, ze[u]);
    }), f.href;
  }
  updateSettings(f, u) {
    var k;
    (k = this.api_iframe.contentWindow) == null || k.postMessage(
      {
        type: "api.request",
        instanceId: "1",
        requestId: f,
        member: f,
        arguments: u
      },
      "https://sketchfab.com"
    );
  }
};
Y.styles = [
  Gr,
  $t`
      :host {
        width: 100%;
      }
    `
];
Q([
  je({ type: String })
], Y.prototype, "uid", 2);
Q([
  je({ type: Array })
], Y.prototype, "settings", 2);
Q([
  je({ type: Object })
], Y.prototype, "options", 2);
Q([
  je({ type: Boolean })
], Y.prototype, "fullScreen", 2);
Q([
  qr("#api_iframe")
], Y.prototype, "api_iframe", 2);
Q([
  It({ slot: "loader" })
], Y.prototype, "_Loaders", 2);
Q([
  It({ slot: "button" })
], Y.prototype, "_Btuttons", 2);
Q([
  Be()
], Y.prototype, "viewr_opacity", 2);
Q([
  Be()
], Y.prototype, "show_buttons", 2);
Q([
  Be()
], Y.prototype, "show_loaders", 2);
Y = Q([
  zr("sketchfab-viewer")
], Y);
const sn = Xr(
  rn,
  "sketchfab-viewer",
  Y,
  {
    updateSettings: "update-settings"
  }
);
export {
  Y as SketchfabViewer,
  sn as SketchfabViewerReact
};
